#ifndef PARTICLE3D_H
#define PARTICLE3D_H

#include "Particles3DTypes.h"

template<UINT NB_MAX_Emiter3DS, UINT NB_MAX_TOTAL_Particles, Draw3DParticleFct FCT_DRAWParticle3D> class Particle3DPool
{
   public:
      
   inline Particle3DPool();
   inline ~Particle3DPool();
   
   inline Emiter3D*  AddEmiter(const vec4x& _vSourcePos, UINT _iNbParticles);
   inline void     RemoveEmiter(Emiter3D* _pEmiter3D); // DONT FORGET TO DELETE USER DATA IN Emiter3D BEFORE REMOVING

   inline void     DoAllWithoutDrawing(const Camera3D& _pCamera3D, UINT _iCurTime, const fixed_t& _fElapsedTime);
   inline void     DrawPool(USHORT* _pData);
   
   inline void     LogPool();

   private:
      
   inline void       DoEmiter3DCulling(Emiter3D * _pEmiter3D, const Camera3D & _pCamera3D);
   inline void       Element3D3Dto2D(Element3D* _arrayElements, UINT _iNbElements, const Camera3D& _pCamera3D);
   inline void       DrawElement(Element3D* _arrayElements, UINT _iNbElements, USHORT* _pData);
      
   inline void       AddEmiter3DSorted(Emiter3D * pEmiter3D);
      
   inline void       UpdateEmiter3DsPool(const Camera3D& _pCamera3D, UINT _iCurTime, const fixed_t& _fElapsedTime);
   inline void       UpdateParticlesPool(const Camera3D& _pCamera3D, UINT _iCurTime, const fixed_t& _fElapsedTime);
   
   inline void       FreeEmiter3DPool(Emiter3D * _pEmiter3D);
   inline Emiter3D*    AllocEmiter3DPool(UINT _iNbParticles);
   inline void       FreeParticle3DPool(Particle3D* _pParticle3D);
   inline Particle3D*  AllocParticle3DPool(UINT _iNbParticles);

      struct
      {
         Element3D    m_arrayElementsPool[NB_MAX_TOTAL_Particles];
         Particle3D   m_arrayParticlesPool[NB_MAX_TOTAL_Particles];
         bool       m_arrayParticlesUse[NB_MAX_TOTAL_Particles];
         UINT       m_arrayParticlesSize[NB_MAX_TOTAL_Particles];
         Emiter3D     m_arrayEmiter3DsPool[NB_MAX_Emiter3DS];
         bool       m_arrayEmiter3DsUse[NB_MAX_Emiter3DS];
         Emiter3D*    m_arrayEmiter3DsSorted[NB_MAX_Emiter3DS];
         UINT       m_nbEmiter3DsToDisplay;
      }              m_Pool;      
};

#include "Particle3D.inl"

#endif
