#ifndef PARTICLES_TYPE_H
#define PARTICLES_TYPE_H

struct Element;
struct Particle;
struct Emiter;

typedef void (*UpdateParticleFct)(Emiter* _pEmiter, Particle* _pParticle, UINT _iCurTime, UINT _iElapsedTime);
typedef void (*UpdateEmiterFct)(Emiter* _pEmiter, UINT _iCurTime, UINT _iElapsedTime);
typedef void (*DrawParticleFct)(UINT _iIdx, USHORT _iColor, USHORT * _pData);

struct Element
{
       vec2D      m_3DPos;
       USHORT     m_3DColor;
       vec2D      m_2DPos;
       bool       m_visible2D;
};

struct Particle
{
       void*      m_pUserData;

       UINT       m_iEndTime;
       Element*   m_pElement;
};

struct Emiter
{
       void*      m_pUserData;

       UINT       m_iNbParticles;
       
       vec2D       m_vSource3DPos;
       UINT       m_fSourceSize;
       bool       m_visible3D;

       Element*   m_arrayElements;
       Particle*  m_arrayParticles;
       
       UpdateParticleFct   m_fctUpdateParticles;
       UpdateEmiterFct     m_fctUpdateEmiter;
};

struct Camera
{
       vec2D    m_3DPos;
       UINT   m_iDiv;
};

#endif
