#ifndef PARTICLES3D_DRAW_SAMPLES_H
#define PARTICLES3D_DRAW_SAMPLES_H

#include "utils3D.h"

inline void DrawParticles3D_SET(UINT _iIdx, fixed_t _fZ, USHORT _iColor, USHORT * _pData)
{
      _pData[_iIdx] = _iColor;
}

inline void DrawParticles3D_SET_BLUR4(UINT _iIdx, fixed_t _fZ, USHORT _iColor, USHORT * _pData)
{
   DrawParticles3D_SET(_iIdx, _fZ, _iColor, _pData);
   
   USHORT r2 = (_iColor >> 11) & 0x1F; 
   USHORT g2 = (_iColor >> 5) & 0x3F; 
   USHORT b2 = (_iColor >> 0) & 0x1F;           
   r2 >>= 1; g2 >>= 1; b2 >>= 1;
   USHORT iBlur4Col = COLOR_RGB16(r2, g2, b2);
   DrawParticles3D_SET(_iIdx + 1, _fZ, iBlur4Col, _pData);
   DrawParticles3D_SET(_iIdx - 1, _fZ, iBlur4Col, _pData);
   DrawParticles3D_SET(_iIdx + SCREEN_WIDTH, _fZ, iBlur4Col, _pData);
   DrawParticles3D_SET(_iIdx - SCREEN_WIDTH, _fZ, iBlur4Col, _pData);
}

inline void DrawParticles3D_SET_BLUR8(UINT _iIdx, fixed_t _fZ, USHORT _iColor, USHORT * _pData)
{
   DrawParticles3D_SET(_iIdx, _fZ, _iColor, _pData);
   
   USHORT r2 = (_iColor >> 11) & 0x1F; 
   USHORT g2 = (_iColor >> 5) & 0x3F; 
   USHORT b2 = (_iColor >> 0) & 0x1F;           
   r2 >>= 1; g2 >>= 1; b2 >>= 1;
   USHORT iBlur4Col = COLOR_RGB16(r2, g2, b2);
   DrawParticles3D_SET(_iIdx + 1,              _fZ, iBlur4Col, _pData);
   DrawParticles3D_SET(_iIdx - 1,              _fZ, iBlur4Col, _pData);
   DrawParticles3D_SET(_iIdx + SCREEN_WIDTH,   _fZ, iBlur4Col, _pData);
   DrawParticles3D_SET(_iIdx - SCREEN_WIDTH,   _fZ, iBlur4Col, _pData);
   
   r2 >>= 1; g2 >>= 1; b2 >>= 1;
   USHORT iBlur8Col = COLOR_RGB16(r2, g2, b2);
   DrawParticles3D_SET(_iIdx + (-1 - SCREEN_WIDTH),  _fZ, iBlur8Col, _pData);
   DrawParticles3D_SET(_iIdx + (1 - SCREEN_WIDTH),   _fZ, iBlur8Col, _pData);
   DrawParticles3D_SET(_iIdx + (-1 + SCREEN_WIDTH),  _fZ, iBlur8Col, _pData);
   DrawParticles3D_SET(_iIdx + (1 + SCREEN_WIDTH),   _fZ, iBlur8Col, _pData);
}

#endif
