#ifndef PARTICULE_COMETE_H
#define PARTICULE_COMETE_H

#define COMETE_PARTICLE_MIN_DURATION      64
#define COMETE_PARTICLE_RAND_DURATION     512
static void  CometeParticlesInit(Emiter* _pEmiter)
{
   // USER DATA INIT
   vec2D* arrayParticleDir = new vec2D[_pEmiter->m_iNbParticles + 1];
   _pEmiter->m_pUserData = arrayParticleDir;
   
   Particle* pCurParticle = _pEmiter->m_arrayParticles;
   UINT iNbParticles = _pEmiter->m_iNbParticles;
   for (UINT i = iNbParticles; i != 0; --i)
   {
         pCurParticle->m_pUserData = arrayParticleDir + i;
         pCurParticle++;
   }
   *arrayParticleDir = vec2D((1), (1));
}

static void CometeEmiters(Emiter* _pEmiter, UINT _iCurTime, UINT _fElapsedTime)
{
      LOGASSERT(_pEmiter != 0, "CometeEmiters : _pEmiter == NULL");
      
#define COMETE_SPEED (3)
      vec2D *pDir = ((vec2D*)_pEmiter->m_pUserData);
      _pEmiter->m_vSource3DPos += (*pDir) * _fElapsedTime;
      if (_pEmiter->m_vSource3DPos.x < 0) 
         pDir->x = 1;
      if (_pEmiter->m_vSource3DPos.x > (SCREEN_WIDTH * 10))
         pDir->x = -1;
      if (_pEmiter->m_vSource3DPos.y < 0) 
         pDir->y = 1;
      if (_pEmiter->m_vSource3DPos.y > (SCREEN_HEIGHT * 10))
         pDir->y = -1;
}

static void CometeParticles(Emiter* _pEmiter, Particle* _pParticle, UINT _iCurTime, UINT _fElapsedTime)
{
      LOGASSERT(_pEmiter != 0, "CometeParticles : _pEmiter == NULL");
      LOGASSERT(_pParticle != 0, "CometeParticles : _pParticle == NULL");
      LOGASSERT(_pParticle->m_pElement != 0, "CometeParticles : _pParticle->m_pElement == NULL");
 
     Element * elm = _pParticle->m_pElement;
     
     if (_pParticle->m_iEndTime == 0)
     {
         // PARTICLE START
        LOGASSERT(_pParticle->m_pUserData != 0, "CometeParticles / INIT : _pParticle->m_pUserData == NULL");

        _pParticle->m_iEndTime = _iCurTime + COMETE_PARTICLE_MIN_DURATION + (rand() % COMETE_PARTICLE_RAND_DURATION);

        int dx, dy, dz;
        int r = rand();
        dx = (r & 0x1F);
        dy = ((r >> 5) & 0x3F);
        dz = ((r >> 11) & 0x1F);
        elm->m_3DColor = COLOR_RGB16(dx, dy, dz);
        elm->m_3DPos = _pEmiter->m_vSource3DPos + vec2D((dx), (dy)) * 4;
     }
     else
     {
         if (_pParticle->m_iEndTime < _iCurTime)
         {
            // RESTART            
            _pParticle->m_iEndTime = 0;
         }
         else
         {
            // UPDATE
         }
     }
}


#endif
