#ifndef PARTICULE_FEU_H
#define PARTICULE_FEU_H

#define FEU_PARTICLE_MIN_DURATION      64
#define FEU_PARTICLE_RAND_DURATION     256
static void  FeuParticlesInit(Emiter* _pEmiter)
{
   // USER DATA INIT
   vec2D* arrayParticleDir = new vec2D[_pEmiter->m_iNbParticles + 1];
   _pEmiter->m_pUserData = arrayParticleDir;
   
   Particle* pCurParticle = _pEmiter->m_arrayParticles;
   UINT iNbParticles = _pEmiter->m_iNbParticles;
   for (UINT i = iNbParticles; i != 0; --i)
   {
         pCurParticle->m_pUserData = arrayParticleDir + i;
         pCurParticle++;
   }
   *arrayParticleDir = vec2D((1), (0));
}

static void FeuParticles(Emiter* _pEmiter, Particle* _pParticle, UINT _iCurTime, UINT _fElapsedTime)
{
      LOGASSERT(_pEmiter != 0, "FeuParticles : _pEmiter == NULL");
      LOGASSERT(_pParticle != 0, "FeuParticles : _pParticle == NULL");
      LOGASSERT(_pParticle->m_pElement != 0, "FeuParticles : _pParticle->m_pElement == NULL");
 
     Element * elm = _pParticle->m_pElement;
     
     if (_pParticle->m_iEndTime == 0)
     {
         // PARTICLE START
        LOGASSERT(_pParticle->m_pUserData != 0, "FeuParticles / INIT : _pParticle->m_pUserData == NULL");

        _pParticle->m_iEndTime = _iCurTime + FEU_PARTICLE_MIN_DURATION + (rand() % FEU_PARTICLE_RAND_DURATION);

        UINT dx, dy, dz;
        UINT r = rand();
        dx = (r & 0x1F);
        dy = ((r >> 5) & 0x3F);
        dz = ((r >> 11) & 0x1F);
        elm->m_3DColor = (0x1F << 11) | (dy << 5);
        vec2D* pDir = (vec2D*)_pParticle->m_pUserData;
        *pDir = vec2D((0), (-4));
        elm->m_3DPos = _pEmiter->m_vSource3DPos + vec2D(((int)dx - 0xF) * 16, ((int)dy - 0xF) * 16);
     }
     else
     {
         if (_pParticle->m_iEndTime < _iCurTime)
         {
            // RESTART            
            _pParticle->m_iEndTime = 0;
         }
         else
         {
            // UPDATE
            LOGASSERT(_pParticle->m_pUserData != 0, "FeuParticles / UPDATE : _pParticle->m_pUserData == NULL");
 
            vec2D vDir = *(vec2D*)_pParticle->m_pUserData;
            elm->m_3DPos += vDir * _fElapsedTime;
         }
     }
}


#endif
