#ifndef PARTICULE_FEU3D_H
#define PARTICULE_FEU3D_H

#define FEU3D_PARTICLE_MIN_DURATION      64
#define FEU3D_PARTICLE_RAND_DURATION     256
static void  Feu3DParticlesInit(Emiter3D* _pEmiter)
{
   // USER DATA INIT
   vec4x* arrayParticleDir = new vec4x[_pEmiter->m_iNbParticles + 1];
   _pEmiter->m_pUserData = arrayParticleDir;
   
   Particle3D* pCurParticle = _pEmiter->m_arrayParticles;
   UINT iNbParticles = _pEmiter->m_iNbParticles;
   for (UINT i = iNbParticles; i != 0; --i)
   {
         pCurParticle->m_pUserData = arrayParticleDir + i;
         pCurParticle++;
   }
   *arrayParticleDir = vec4x(FIXED(1), FIXED(0), FIXED(0), FIXED(1));
}

static void Feu3DParticles(Emiter3D* _pEmiter, Particle3D* _pParticle, UINT _iCurTime, const fixed_t& _fElapsedTime)
{
      LOGASSERT(_pEmiter != 0, "FeuParticles : _pEmiter == NULL");
      LOGASSERT(_pParticle != 0, "FeuParticles : _pParticle == NULL");
      LOGASSERT(_pParticle->m_pElement != 0, "FeuParticles : _pParticle->m_pElement == NULL");
 
     Element3D * elm = _pParticle->m_pElement;
     
     if (_pParticle->m_iEndTime == 0)
     {
         // PARTICLE START
        LOGASSERT(_pParticle->m_pUserData != 0, "FeuParticles / INIT : _pParticle->m_pUserData == NULL");

        _pParticle->m_iEndTime = _iCurTime + FEU3D_PARTICLE_MIN_DURATION + (rand() % FEU3D_PARTICLE_RAND_DURATION);

        UINT dx, dy, dz;
        UINT r = rand();
        dx = (r & 0x1F);
        dy = ((r >> 5) & 0x1F);
        dz = ((r >> 10) & 0x1F);
        elm->m_3DColor = (dz << 6) | (0xF800);
        vec4x* pDir = (vec4x*)_pParticle->m_pUserData;
        *pDir = vec4x(FIXED(0), FIXED(0), FIXED(0x10), FIXED(0));
        elm->m_3DPos = _pEmiter->m_vSource3DPos + vec4x(FIXED((int)dx - 0xF) * FIXED(0.05f), FIXED((int)dy - 0xF) * FIXED(0.05f), FIXED((int)dz - 0xF) * FIXED(0.05f), FIXED(0));
     }
     else
     {
         if (_pParticle->m_iEndTime < _iCurTime)
         {
            // RESTART            
            _pParticle->m_iEndTime = 0;
         }
         else
         {
            // UPDATE
            LOGASSERT(_pParticle->m_pUserData != 0, "FeuParticles / UPDATE : _pParticle->m_pUserData == NULL");
 
            vec4x vDir = *(vec4x*)_pParticle->m_pUserData;
            vDir.x *= _fElapsedTime;
            vDir.y *= _fElapsedTime;
            vDir.z *= _fElapsedTime;
            elm->m_3DPos += vDir;
         }
     }
}


#endif
