#ifndef PARTICULE_FONTAINE_H
#define PARTICULE_FONTAINE_H

#define FONTAINE_PARTICLE_DURATION           256
#define FONTAINE_PARTICLE_EMITER_RAND_DURATION           64
static void  FontaineParticlesInit(Emiter* _pEmiter)
{
   // USER DATA INIT
   vec2D* arrayParticleDir = new vec2D[_pEmiter->m_iNbParticles + 1];
   _pEmiter->m_pUserData = arrayParticleDir;
   
   Particle* pCurParticle = _pEmiter->m_arrayParticles;
   UINT iNbParticles = _pEmiter->m_iNbParticles;
   for (UINT i = iNbParticles; i != 0; --i)
   {
         pCurParticle->m_pUserData = arrayParticleDir + i;
         pCurParticle++;
   }
   *arrayParticleDir = vec2D(0, 0);
}
static void FontaineEmiters(Emiter* _pEmiter, UINT _iCurTime, UINT _fElapsedTime)
{
      LOGASSERT(_pEmiter != 0, "CometeEmiters : _pEmiter == NULL");
      
      vec2D *pDir = ((vec2D*)_pEmiter->m_pUserData);
      pDir->x -= _fElapsedTime;
      if (pDir->x <= 0)
      {
         pDir->x = FONTAINE_PARTICLE_DURATION + (rand() % FONTAINE_PARTICLE_EMITER_RAND_DURATION);
         _pEmiter->m_vSource3DPos.x = (rand() % SCREEN_WIDTH) * 10;
         _pEmiter->m_vSource3DPos.y = (rand() % SCREEN_HEIGHT) * 10;
      }
}
static void FontaineParticles(Emiter* _pEmiter, Particle* _pParticle, UINT _iCurTime, UINT _fElapsedTime)
{
      LOGASSERT(_pEmiter != 0, "FontaineParticles : _pEmiter == NULL");
      LOGASSERT(_pParticle != 0, "FontaineParticles : _pParticle == NULL");
      LOGASSERT(_pParticle->m_pElement != 0, "FontaineParticles : _pParticle->m_pElement == NULL");
 
     Element * elm = _pParticle->m_pElement;
     
     if (_pParticle->m_iEndTime == 0)
     {
         // PARTICLE START
        LOGASSERT(_pParticle->m_pUserData != 0, "FontaineParticles / INIT : _pParticle->m_pUserData == NULL");

        elm->m_3DPos = _pEmiter->m_vSource3DPos;
         vec2D *pT = ((vec2D*)_pEmiter->m_pUserData);
        _pParticle->m_iEndTime = _iCurTime + pT->x;

        int dx, dy, dz;
        int r = rand();
        dx = (r & 0x1F);
        dy = ((r >> 5) & 0x1F);
        dz = ((r >> 10) & 0x1F);
        elm->m_3DColor = dx | (dy << 5);
        vec2D* pDir = (vec2D*)_pParticle->m_pUserData;
        *pDir = vec2D(((dx % 21) - 10), ((dy % 21) - 10));
     }
     else
     {
         if (_pParticle->m_iEndTime < _iCurTime)
         {
            // RESTART            
            _pParticle->m_iEndTime = 0;
         }
         else
         {
            // UPDATE
            LOGASSERT(_pParticle->m_pUserData != 0, "FontaineParticles / UPDATE : _pParticle->m_pUserData == NULL");
 
            vec2D vDir = *(vec2D*)_pParticle->m_pUserData;
            elm->m_3DPos += (vDir * _fElapsedTime) / 4;
         }
     }
}


#endif
