#ifndef PARTICULE_FONTAINE3D_H
#define PARTICULE_FONTAINE3D_H

#define FONTAINE3D_PARTICLE_MIN_DURATION      64
#define FONTAINE3D_PARTICLE_RAND_DURATION     256
static void  Fontaine3DParticlesInit(Emiter3D* _pEmiter)
{
   // USER DATA INIT
   vec4x* arrayParticleDir = new vec4x[_pEmiter->m_iNbParticles + 1];
   _pEmiter->m_pUserData = arrayParticleDir;
   
   Particle3D* pCurParticle = _pEmiter->m_arrayParticles;
   UINT iNbParticles = _pEmiter->m_iNbParticles;
   for (UINT i = iNbParticles; i != 0; --i)
   {
         pCurParticle->m_pUserData = arrayParticleDir + i;
         pCurParticle++;
   }
   *arrayParticleDir = vec4x(FIXED(1), FIXED(0), FIXED(0), FIXED(1));
}

static void Fontaine3DParticles(Emiter3D* _pEmiter, Particle3D* _pParticle, UINT _iCurTime, const fixed_t& _fElapsedTime)
{
      LOGASSERT(_pEmiter != 0, "FontaineParticles : _pEmiter == NULL");
      LOGASSERT(_pParticle != 0, "FontaineParticles : _pParticle == NULL");
      LOGASSERT(_pParticle->m_pElement != 0, "FontaineParticles : _pParticle->m_pElement == NULL");
 
     Element3D * elm = _pParticle->m_pElement;
     
     if (_pParticle->m_iEndTime == 0)
     {
         // PARTICLE START
        LOGASSERT(_pParticle->m_pUserData != 0, "FontaineParticles / INIT : _pParticle->m_pUserData == NULL");

        elm->m_3DPos = _pEmiter->m_vSource3DPos;
        _pParticle->m_iEndTime = _iCurTime + FONTAINE3D_PARTICLE_MIN_DURATION + (rand() % FONTAINE3D_PARTICLE_RAND_DURATION);

        int dx, dy, dz;
        int r = rand();
        dx = (r & 0x1F);
        dy = ((r >> 5) & 0x1F);
        dz = ((r >> 10) & 0x1F);
        elm->m_3DColor = (dz << 6) | (0xFF);
        vec4x* pDir = (vec4x*)_pParticle->m_pUserData;
        *pDir = vec4x(FIXED(dx - 0xF), FIXED(dy - 0xF), FIXED(0x1F - (dz & 7)), FIXED(0));
     }
     else
     {
         if (_pParticle->m_iEndTime < _iCurTime)
         {
            // RESTART            
            _pParticle->m_iEndTime = 0;
         }
         else
         {
            // UPDATE
            LOGASSERT(_pParticle->m_pUserData != 0, "FontaineParticles / UPDATE : _pParticle->m_pUserData == NULL");
 
            vec4x vDir = *(vec4x*)_pParticle->m_pUserData;
            vDir += vec4x(FIXED(0), FIXED(0), FIXED(-150) * _fElapsedTime, FIXED(0));
            *(vec4x*)_pParticle->m_pUserData = vDir;
            vDir.x *= _fElapsedTime * FIXED(0.3f);
            vDir.y *= _fElapsedTime * FIXED(0.3f);
            vDir.z *= _fElapsedTime;
            vDir.w = 0;
            elm->m_3DPos += vDir;
         }
     }
}


#endif
